package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesPackingPartTypeService;
import cn.estsh.i3plus.ext.mes.api.base.IMesPackingRuleDetailService;
import cn.estsh.i3plus.ext.mes.pojo.util.MesExtConstWords;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesPackingPartType;
import cn.estsh.i3plus.pojo.mes.bean.MesPackingRuleDetail;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@Service
@Slf4j
public class MesPackingRuleDetailService extends BaseMesService<MesPackingRuleDetail> implements IMesPackingRuleDetailService {

    @Autowired
    private IMesPackingPartTypeService packingPartTypeService;

    @Override
    protected void setPackQueryBean(MesPackingRuleDetail bean, DdlPackBean packBean) {
        DdlPreparedPack.getStringLikerPack(bean.getPackageCode(), MesExtConstWords.PACKAGE_CODE, packBean);
        DdlPreparedPack.getStringLikerPack(bean.getPartNo(), MesExtConstWords.PART_NO, packBean);
        DdlPreparedPack.getStringEqualPack(bean.getPartType(), MesExtConstWords.PART_TYPE, packBean);
    }

    @Override
    public void setBeanModel(List<MesPackingRuleDetail> list) {
        if (CollectionUtils.isEmpty(list)) return;

        DdlPackBean packBean = DdlPackBean.getDdlPackBean(list.get(0).getOrganizeCode());
        List<MesPackingPartType> packingPartTypeList = packingPartTypeService.findAll(packBean);
        Map<String, String> packingPartTypeMap = CollectionUtils.isEmpty(packingPartTypeList) ? null :
                packingPartTypeList.stream().filter(o -> null != o).collect(Collectors.toMap(MesPackingPartType::getPartType, MesPackingPartType::getPartTypeName));

        if (!CollectionUtils.isEmpty(packingPartTypeMap)) {
            list.forEach(o -> {
                o.setPartTypeName(packingPartTypeMap.get(o.getPartType()));
            });
        }
    }

}
